module Actions
  module Errors
    class Error < StandardError
      attr_reader :context

      def initialize(message, context)
        super(message)
        @context = context
      end
    end

    class Failure < Error
    end

    class ValidationFailed < Error
    end

    class InvalidType < Error
    end
  end
end
