require "actions/action"

module Actions
  module Group

    def self.included(base)
      base.class_eval do
        include Action
        extend ClassMethods
        include InstanceMethods
      end
    end

    module ClassMethods

      def actions(*actions)
        @actions ||= []
        if actions.length > 0
          @actions = actions.freeze
        else
          @actions
        end
      end

    end

    module InstanceMethods

      def call
        self.class.actions.each { |action| action.call(context) }
        context
      end

    end

  end
end
