module Actions
  module StorageAdapter
    class ActiveRecord

      class Record < ::ActiveRecord::Base
        serialize :input, JSON
        serialize :output, JSON

        enum status: {
          started: 0,
          done: 1,
          failed: 2,
          rollback_started: 3,
          rollback_succeeded: 4,
          rollback_failed: 5,
          validation_failed: 6
        }
      end

      def initialize(table_name)
        @table_name = table_name
        @record_class = Class.new(Record)
        @record_class.table_name = table_name
      end

      def store(name:, context_id:, input:, output:, status:)
        @record_class.create!(
          name: name,
          context_id: context_id,
          input: input,
          output: output,
          status: status
        )
      end

      def records
        @record_class
      end

    end
  end
end
